/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
 * 
 */
package jp.mosp.common.part;

import java.util.HashMap;
import java.util.Map;

import jp.mosp.common.common.MospException;

/**
 * Partを保持する基本クラス
 * @author yoshida
 *	@version 0.0.1
 */
public abstract class BaseStore {
	
	/**
	 * PartInfoインスタンス
	 */
	private PartInfo				partInfo;
	
	/**
	 * Part保持Map
	 */
	private Map<String, BasePart>	partMap;
	

	/**
	 * コンストラクタ
	 */
	public BaseStore() {
		partMap = new HashMap<String, BasePart>();
	}
	
	/**
	 * 対象Partインスタンス取得
	 * @param partClassName 	対象Partクラス名
	 * @return 対象Partインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public BasePart get(String partClassName) throws MospException {
		if (!partMap.containsKey(partClassName)) {
			add(partClassName);
		}
		return partMap.get(partClassName);
	}
	
	/**
	 * 対象Partインスタンス取得
	 * @param cls 	対象Partクラス
	 * @return 対象Partインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public BasePart get(Class<?> cls) throws MospException {
		return get(cls.getCanonicalName());
	}
	
	/**
	 * 対象Partインスタンス追加
	 * @param partClassName	 	対象Partクラス名
	 * @throws MospException MosP例外処理が発生した場合
	 */
	private void add(String partClassName) throws MospException {
		partMap.put(partClassName, PartManager.getPreparedPart(partClassName, partInfo));
	}
	
	/**
	 * 保持インスタンス全消去
	 */
	public void clear() {
		partMap.clear();
	}
	
	/**
	 * @param partInfo セットする partInfo
	 */
	public void setPartInfo(PartInfo partInfo) {
		this.partInfo = partInfo;
	}
	
}
